var objectProto = Object.prototype;
function isPrototype(e) { var t = e && e.constructor; return e === ("function" == typeof t && t.prototype || objectProto); }
var _isPrototype = isPrototype;
function overArg(e, t) { return function (r) { return e(t(r)); }; }
var _overArg = overArg, nativeKeys = _overArg(Object.keys, Object), _nativeKeys = nativeKeys, objectProto$1 = Object.prototype, hasOwnProperty = objectProto$1.hasOwnProperty;
function baseKeys(e) { if (!_isPrototype(e))
    return _nativeKeys(e); var t = []; for (var r in Object(e))
    hasOwnProperty.call(e, r) && "constructor" != r && t.push(r); return t; }
var _baseKeys = baseKeys, commonjsGlobal = "undefined" != typeof window ? window : "undefined" != typeof global ? global : "undefined" != typeof self ? self : {};
function createCommonjsModule(e, t) { return e(t = { exports: {} }, t.exports), t.exports; }
var freeGlobal = "object" == typeof commonjsGlobal && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal, _freeGlobal = freeGlobal, freeSelf = "object" == typeof self && self && self.Object === Object && self, root = _freeGlobal || freeSelf || Function("return this")(), _root = root, Symbol = _root.Symbol, _Symbol = Symbol, objectProto$2 = Object.prototype, hasOwnProperty$1 = objectProto$2.hasOwnProperty, nativeObjectToString = objectProto$2.toString, symToStringTag = _Symbol ? _Symbol.toStringTag : void 0;
function getRawTag(e) { var t = hasOwnProperty$1.call(e, symToStringTag), r = e[symToStringTag]; try {
    e[symToStringTag] = void 0;
}
catch (e) { } var a = nativeObjectToString.call(e); return t ? e[symToStringTag] = r : delete e[symToStringTag], a; }
var _getRawTag = getRawTag, objectProto$3 = Object.prototype, nativeObjectToString$1 = objectProto$3.toString;
function objectToString(e) { return nativeObjectToString$1.call(e); }
var _objectToString = objectToString, nullTag = "[object Null]", undefinedTag = "[object Undefined]", symToStringTag$1 = _Symbol ? _Symbol.toStringTag : void 0;
function baseGetTag(e) { return null == e ? void 0 === e ? undefinedTag : nullTag : symToStringTag$1 && symToStringTag$1 in Object(e) ? _getRawTag(e) : _objectToString(e); }
var _baseGetTag = baseGetTag;
function isObject(e) { var t = typeof e; return null != e && ("object" == t || "function" == t); }
var isObject_1 = isObject, asyncTag = "[object AsyncFunction]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
function isFunction(e) { if (!isObject_1(e))
    return !1; var t = _baseGetTag(e); return t == funcTag || t == genTag || t == asyncTag || t == proxyTag; }
var isFunction_1 = isFunction, coreJsData = _root["__core-js_shared__"], _coreJsData = coreJsData, maskSrcKey = function () { var e = /[^.]+$/.exec(_coreJsData && _coreJsData.keys && _coreJsData.keys.IE_PROTO || ""); return e ? "Symbol(src)_1." + e : ""; }();
function isMasked(e) { return !!maskSrcKey && maskSrcKey in e; }
var _isMasked = isMasked, funcProto = Function.prototype, funcToString = funcProto.toString;
function toSource(e) { if (null != e) {
    try {
        return funcToString.call(e);
    }
    catch (e) { }
    try {
        return e + "";
    }
    catch (e) { }
} return ""; }
var _toSource = toSource, reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reIsHostCtor = /^\[object .+?Constructor\]$/, funcProto$1 = Function.prototype, objectProto$4 = Object.prototype, funcToString$1 = funcProto$1.toString, hasOwnProperty$2 = objectProto$4.hasOwnProperty, reIsNative = RegExp("^" + funcToString$1.call(hasOwnProperty$2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
function baseIsNative(e) { return !(!isObject_1(e) || _isMasked(e)) && (isFunction_1(e) ? reIsNative : reIsHostCtor).test(_toSource(e)); }
var _baseIsNative = baseIsNative;
function getValue(e, t) { return null == e ? void 0 : e[t]; }
var _getValue = getValue;
function getNative(e, t) { var r = _getValue(e, t); return _baseIsNative(r) ? r : void 0; }
var _getNative = getNative, DataView = _getNative(_root, "DataView"), _DataView = DataView, Map = _getNative(_root, "Map"), _Map = Map, Promise = _getNative(_root, "Promise"), _Promise = Promise, Set = _getNative(_root, "Set"), _Set = Set, WeakMap = _getNative(_root, "WeakMap"), _WeakMap = WeakMap, mapTag = "[object Map]", objectTag = "[object Object]", promiseTag = "[object Promise]", setTag = "[object Set]", weakMapTag = "[object WeakMap]", dataViewTag = "[object DataView]", dataViewCtorString = _toSource(_DataView), mapCtorString = _toSource(_Map), promiseCtorString = _toSource(_Promise), setCtorString = _toSource(_Set), weakMapCtorString = _toSource(_WeakMap), getTag = _baseGetTag;
(_DataView && getTag(new _DataView(new ArrayBuffer(1))) != dataViewTag || _Map && getTag(new _Map) != mapTag || _Promise && getTag(_Promise.resolve()) != promiseTag || _Set && getTag(new _Set) != setTag || _WeakMap && getTag(new _WeakMap) != weakMapTag) && (getTag = function (e) { var t = _baseGetTag(e), r = t == objectTag ? e.constructor : void 0, a = r ? _toSource(r) : ""; if (a)
    switch (a) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
    } return t; });
var _getTag = getTag, MAX_SAFE_INTEGER = 9007199254740991;
function isLength(e) { return "number" == typeof e && e > -1 && e % 1 == 0 && e <= MAX_SAFE_INTEGER; }
var isLength_1 = isLength;
function isArrayLike(e) { return null != e && isLength_1(e.length) && !isFunction_1(e); }
var isArrayLike_1 = isArrayLike, isArray = Array.isArray, isArray_1 = isArray;
function isObjectLike(e) { return null != e && "object" == typeof e; }
var isObjectLike_1 = isObjectLike, stringTag = "[object String]";
function isString(e) { return "string" == typeof e || !isArray_1(e) && isObjectLike_1(e) && _baseGetTag(e) == stringTag; }
var isString_1 = isString;
function baseProperty(e) { return function (t) { return null == t ? void 0 : t[e]; }; }
var _baseProperty = baseProperty, asciiSize = _baseProperty("length"), _asciiSize = asciiSize, rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsVarRange = "\\ufe0e\\ufe0f", rsZWJ = "\\u200d", reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
function hasUnicode(e) { return reHasUnicode.test(e); }
var _hasUnicode = hasUnicode, rsAstralRange$1 = "\\ud800-\\udfff", rsComboMarksRange$1 = "\\u0300-\\u036f", reComboHalfMarksRange$1 = "\\ufe20-\\ufe2f", rsComboSymbolsRange$1 = "\\u20d0-\\u20ff", rsComboRange$1 = rsComboMarksRange$1 + reComboHalfMarksRange$1 + rsComboSymbolsRange$1, rsVarRange$1 = "\\ufe0e\\ufe0f", rsAstral = "[" + rsAstralRange$1 + "]", rsCombo = "[" + rsComboRange$1 + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange$1 + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsZWJ$1 = "\\u200d", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange$1 + "]?", rsOptJoin = "(?:" + rsZWJ$1 + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")", reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
function unicodeSize(e) { for (var t = reUnicode.lastIndex = 0; reUnicode.test(e);)
    ++t; return t; }
var _unicodeSize = unicodeSize;
function stringSize(e) { return _hasUnicode(e) ? _unicodeSize(e) : _asciiSize(e); }
var _stringSize = stringSize, mapTag$1 = "[object Map]", setTag$1 = "[object Set]";
function size(e) { if (null == e)
    return 0; if (isArrayLike_1(e))
    return isString_1(e) ? _stringSize(e) : e.length; var t = _getTag(e); return t == mapTag$1 || t == setTag$1 ? e.size : _baseKeys(e).length; }
var size_1 = size;
function preventDefault() { Object.defineProperty(this, "defaultPrevented", { get: function () { return !0; } }); }
function customEvent(e, t, r, a) {
    if (r === void 0) { r = {}; }
    if (a === void 0) { a = {}; }
    var o = Object.assign({}, { sentAtTime: (new Date).getTime() }, r);
    var s;
    if ("function" == typeof window.CustomEvent)
        s = new CustomEvent(t, { bubbles: !0, cancelable: !0, detail: o });
    else {
        var e_1 = !0, r_1 = !0;
        (s = document.createEvent("CustomEvent")).initCustomEvent(t, e_1, r_1, { detail: o });
    }
    return Object.defineProperties(s, { preventDefault: { value: preventDefault, writable: !0 } }), a instanceof Element && Object.defineProperties(s, { relatedTarget: { value: a, writable: !0 } }), e.dispatchEvent(s), s;
}
function removeClass(e, t) { e.classList ? e.classList.remove(t) : e.className = e.className.replace(new RegExp("(^|\\b)" + t.split(" ").join("|") + "(\\b|$)", "gi"), " "); }
function addClass(e, t) { e.classList ? e.classList.add(t) : e.className += " " + t; }
function hasClass(e, t) { return e.classList ? e.classList.contains(t) : new RegExp("(^| )" + t + "( |$)", "gi").test(e.className); }
export { commonjsGlobal as a, createCommonjsModule as b, size_1 as c, customEvent as d, removeClass as e, addClass as f, hasClass as g, _baseGetTag as h, isObjectLike_1 as i, _Symbol as j, isArray_1 as k, _hasUnicode as l, _getNative as m, _Map as n, isLength_1 as o, _overArg as p, isObject_1 as q, isArrayLike_1 as r, _freeGlobal as s, _root as t, _baseKeys as u, isString_1 as v, isObject_1 as w, isString_1 as x };
